'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _Day = require('./Day');

var _Day2 = _interopRequireDefault(_Day);

var _DayOfWeek = require('./DayOfWeek');

var _DayOfWeek2 = _interopRequireDefault(_DayOfWeek);

var _Week = require('./Week');

var _Week2 = _interopRequireDefault(_Week);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Calendar = function (_Component) {
  _inherits(Calendar, _Component);

  function Calendar(props) {
    _classCallCheck(this, Calendar);

    var _this = _possibleConstructorReturn(this, (Calendar.__proto__ || Object.getPrototypeOf(Calendar)).call(this, props));

    var date = props.date;
    var month = void 0;
    if (date) {
      month = props.date;
    } else {
      month = props.month;
    }
    _this.state = {
      date: date,
      month: month
    };

    _this.previous = _this.previous.bind(_this);
    _this.next = _this.next.bind(_this);
    _this.handleClick = _this.handleClick.bind(_this);
    return _this;
  }

  _createClass(Calendar, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      _moment2.default.locale(this.props.locale);

      if (!!this.state.date) {
        this.state.date.locale(this.props.locale);
      }

      this.state.month.locale(this.props.locale);
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      _moment2.default.locale(this.props.locale);

      if (!!nextState.date) {
        nextState.date.locale(this.props.locale);
      }

      nextState.month.locale(this.props.locale);
    }
  }, {
    key: 'handleClick',
    value: function handleClick(date) {
      var flag = this.props.onSelect(date, this.state.date, this.state.month);

      if (flag === true) {
        this.setState({
          date: (0, _moment2.default)(date)
        });
      } else if (flag === false) {
        this.setState({
          date: null
        });
      }
    }
  }, {
    key: 'previous',
    value: function previous() {
      this.setState({
        month: (0, _moment2.default)(this.state.month).subtract(1, 'month')
      });
    }
  }, {
    key: 'next',
    value: function next() {
      this.setState({
        month: (0, _moment2.default)(this.state.month).add(1, 'month')
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          startOfWeekIndex = _props.startOfWeekIndex,
          dayRenderer = _props.dayRenderer,
          dayOfWeekFormat = _props.dayOfWeekFormat;


      var classes = ['Calendar', this.props.className].join(' ');

      var today = (0, _moment2.default)();

      var format = dayOfWeekFormat && dayOfWeekFormat !== '' && (0, _moment2.default)(today, dayOfWeekFormat).isValid() ? dayOfWeekFormat : 'dd';

      var date = this.state.date;
      var month = this.state.month;

      var current = month.clone().startOf('month').day(startOfWeekIndex);
      if (current.date() > 1 && current.date() < 7) {
        current.subtract(7, 'd');
      }

      var end = month.clone().endOf('month').day(7 + startOfWeekIndex);

      if (end.date() > 7) {
        end.subtract(7, 'd');
      }

      var elements = [];
      var days = [];
      var week = 1;
      var i = 1;
      var daysOfWeek = [];
      var day = current.clone();
      for (var j = 0; j < 7; j++) {
        var dayOfWeekKey = 'dayOfWeek' + j;
        daysOfWeek.push(_react2.default.createElement(_DayOfWeek2.default, { key: dayOfWeekKey, date: day.clone(), format: format }));
        day.add(1, 'days');
      }
      while (current.isBefore(end)) {
        var dayClasses = this.props.dayClasses(current);
        if (!current.isSame(month, 'month')) {
          dayClasses = dayClasses.concat(['other-month']);
        }
        var props = {
          date: current.clone(),
          selected: date,
          month: month,
          today: today,
          classes: dayClasses,
          handleClick: this.handleClick
        };

        var children = void 0;
        if (!!dayRenderer) {
          children = dayRenderer(props);
        }

        days.push(_react2.default.createElement(
          _Day2.default,
          _extends({ key: i++ }, props),
          children
        ));
        current.add(1, 'days');
        if (current.day() === startOfWeekIndex) {
          var weekKey = 'week' + week++;
          elements.push(_react2.default.createElement(
            _Week2.default,
            { key: weekKey },
            days
          ));
          days = [];
        }
      }

      var nav = void 0;

      if (this.props.useNav) {
        nav = _react2.default.createElement(
          'tr',
          { className: 'month-header' },
          _react2.default.createElement(
            'th',
            { className: 'nav previous' },
            _react2.default.createElement(
              'button',
              { className: 'nav-inner', onClick: this.previous, type: 'button' },
              '\xAB'
            )
          ),
          _react2.default.createElement(
            'th',
            { colSpan: '5' },
            _react2.default.createElement(
              'span',
              { className: 'month' },
              month.format('MMMM')
            ),
            ' ',
            _react2.default.createElement(
              'span',
              { className: 'year' },
              month.format('YYYY')
            )
          ),
          _react2.default.createElement(
            'th',
            { className: 'nav next' },
            _react2.default.createElement(
              'button',
              { className: 'nav-inner', onClick: this.next, type: 'button' },
              '\xBB'
            )
          )
        );
      } else {
        nav = _react2.default.createElement(
          'tr',
          { className: 'month-header' },
          _react2.default.createElement(
            'th',
            { colSpan: '7' },
            _react2.default.createElement(
              'span',
              { className: 'month' },
              month.format('MMMM')
            ),
            ' ',
            _react2.default.createElement(
              'span',
              { className: 'year' },
              month.format('YYYY')
            )
          )
        );
      }

      return _react2.default.createElement(
        'table',
        { className: classes },
        _react2.default.createElement(
          'thead',
          null,
          nav
        ),
        _react2.default.createElement(
          'thead',
          null,
          _react2.default.createElement(
            'tr',
            { className: 'days-header' },
            daysOfWeek
          )
        ),
        _react2.default.createElement(
          'tbody',
          null,
          elements
        )
      );
    }
  }]);

  return Calendar;
}(_react.Component);

Calendar.defaultProps = {
  month: (0, _moment2.default)(),
  dayClasses: function dayClasses() {
    return [];
  },
  useNav: true,
  locale: 'en',
  startOfWeekIndex: 0,
  dayOfWeekFormat: 'dd'
};
Calendar.propTypes = {
  onSelect: _propTypes2.default.func.isRequired,
  date: _propTypes2.default.object,
  month: _propTypes2.default.object,
  dayClasses: _propTypes2.default.func,
  useNav: _propTypes2.default.bool,
  locale: _propTypes2.default.string,
  startOfWeekIndex: _propTypes2.default.number,
  dayRenderer: _propTypes2.default.func,
  dayOfWeekFormat: _propTypes2.default.string
};

exports.default = Calendar;
module.exports = exports.default;